/* contrasts.c
 *
 * routines to create default contrasts matrix and to add others for
 * testing purposes
 *
 * written and copyright (c) by Garf and ff123, 2001
 * http://sjeng.sourceforge.net/
 * http://ff123.net/
 *
 *-------------------- GNU Lesser General Public License -------------------
 * http://www.gnu.org/copyleft/lesser.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *********************************************************************/
#include "bootstrap.h"


/*********************************************************************/
/* create default contrasts matrix based on the number of treatments
 */

void create_default_contrasts(void)
{
  int i;            /* index */
  int j;            /* index */
  int poscontrast;  /* index */
  int negcontrast;  /* index */

  poscontrast = 0;
  negcontrast = 1;
  for (i=0; i<numcompar; i++)
    {
      for (j=0; j<numcompar; j++)
        {
          if (negcontrast == numtreat)
            {
              poscontrast++;
              negcontrast = poscontrast + 1;
            }
          if (poscontrast == j)
              contrasts[i][j] = 1;
          if (negcontrast == j)
            {
              contrasts[i][j] = -1;
              negcontrast++;
              break;
            }
        }
    }
  return;
}

/*********************************************************************/
/* Add additional contrasts.  These are hard coded in for testing
 * the program against examples in Westfall and Young, 1993.
 */

void add_test_contrasts(void)
{
  contrasts[numcompar][0] = -1;
  contrasts[numcompar][1] = -1;
  contrasts[numcompar][2] =  1;
  contrasts[numcompar][3] =  1;
  contrasts[numcompar+1][0] =  1;
  contrasts[numcompar+1][1] = -1;
  contrasts[numcompar+1][2] =  1;
  contrasts[numcompar+1][3] = -1;
  contrasts[numcompar+2][0] =  1;
  contrasts[numcompar+2][1] = -1;
  contrasts[numcompar+2][2] = -1;
  contrasts[numcompar+2][3] =  1;
  numcompar += 3;
}
